#include<iostream>
using namespace std;

/* Implementovane funkce: WHILE */
int nacti_cislo(int minimum, int maximum);
long long faktorial(int n);
long long faktorial0(int n);
double mocnina(double x, int n);

/* Implementovane funkce: IF */
bool je_sude(int i);
bool je_sude1(int i); 
void porovnej(int a, int b);
int nejvetsi(int a, int b, int c);
int nejvetsi1(int a, int b, int c);
void usporadej(int a, int b, int c);

int main()
{
	// prikaz WHILE:
	
	/* Prvni priklad */
	{
		cout << "Cislo a jeho druha mocnina: " << endl;
		int i = 0;
		while (i <= 10)
		{
			cout << i << " " << i * i << endl;
			i++;
		}
	}

	/* Druhy priklad */
	{
		int i;
		/* cyklus ukonceny uzivatelem: 
			v kazde iteraci nactu cislo a vypisu, zda je sude nebo liche
			konec, pokud uzivatel zada 0
		*/
		do {
			cout << "Zadej cele cislo (konec ... 0): ";
			cin >> i;     // POZOR na pripad, kdy uzivatel nezada cislo -> zacykli se!
			je_sude(i);
		} while (i != 0);
	}

	/* Treti priklad */
	{
		int n = nacti_cislo(0, 20);
		cout << "Faktorial cisla " << n << " je " << faktorial(n) << endl;

		cout << "Zadej prirozene cislo (mocnitel): ";
		cin >> n;
		cout << "Zadej realne cislo (mocnenec): ";
		double x;
		cin >> x;
		cout << "Mocnina je " << mocnina(x, n) << endl;
	}
	
	
	// prikaz IF:
	{
		int a, b, c;
		cout << "Zadej tri cisla:" << endl;
		cin >> a;
		cin >> b;
		cin >> c;

		je_sude(a);
		// je_sude1(a);
		porovnej(a, b);
		nejvetsi(a, b, c);
		// nejvetsi1(a, b, c);
		usporadej(a, b, c);

	}

	return 0;
}

/* Funkce nacte z konzole cislo v danem rozsahu hodnot.  */
int nacti_cislo(int minimum, int maximum)
{
	int n;
	do
	{
		cout << "Zadej cislo od " << minimum << " do " << maximum << endl;
		cin >> n;  // POZOR na pripad, kdy uzivatel nezada cislo -> zacykli se!
		if (n < minimum || n > maximum) {
			cout << "Neplatne zadani. Zkus to znovu!" << endl;
		}
	} while (n < minimum || n > maximum);
	return n;
}

/* Funkce spocita a vrati faktorial prirozeneho cisla n. */
long long faktorial(int n)
{
	long long y = 1;   // vysledek
	while (n > 0)
	{
		// y = y * n;
		// n = n - 1;
		y *= n;
		n--;
	}
	return y;
}

/* Funkce spocita a vrati faktorial prirozeneho cisla n. */
long long faktorial0(int n)
{
	long long y = 1;     // vysledek
	int i = 1;           // pomocna promenna
	while (i <= n)
	{
		y *= i;
		i++;
	}
	return y;
}

/* Funkce spocita a vrati hodnotu x^n (n je prirozene cislo). */
double mocnina(double x, int n)
{
	// TODO
	return 0;
}

/* Funkce rozhodne, zda je 'i' sud slo, vype informaci na konzoli. */
bool je_sude(int i)
{
	bool r = (i % 2 == 0);
	if (r)
		cout << "Cislo " << i << " je sude." << endl;
	else
		cout << "Cislo " << i << " je liche." << endl;

	return r;
	//return (i % 2 == 0);
}

/* Funkce rozhodne, zda je 'i' sud slo, vype informaci na konzoli. */
bool je_sude1(int i)
{
	if (i % 2 == 0)
	{
		cout << "Cislo " << i << " je sude." << endl;
		return true;
	}
	else
	{
		cout << "Cislo " << i << " je liche." << endl;
		return false;
	}
}

/* Funkce vype na konzoli informaci o tom, ktere z cisel 'a' a 'b' je vt. */
void porovnej(int a, int b)
{
	if (a < b)
		cout << "Cislo " << b << " je vetsi nez " << a << endl;
	else if (a > b)
		cout << "Cislo " << a << " je vetsi nez " << b << endl;
	else
		cout << "Cisla jsou stejna" << endl;
}

/* Funkce vype na konzoli informaci o tom,
ktere z cisel 'a', 'b' a 'c' je nejvt. Vrt hodnotu maxima. */
int nejvetsi(int a, int b, int c)
{
	int nej;
	if (b > a)
	{
		if (c > b)
			nej = c;
		else
			nej = b;
	}
	else
	{
		if (c > a)
			nej = c;
		else
			nej = a;
	}
	cout << "Nejvetsi z cisel je " << nej << endl;
	return nej;
}

/* Funkce vype na konzoli informaci o tom,
ktere z cisel 'a', 'b' a 'c' je nejvt. Vrt hodnotu maxima. */
int nejvetsi1(int a, int b, int c)
{
	int nej;
	if (a >= b && a >= c)
		nej = a;
	if (b >= a && b >= c)
		nej = b;
	if (c >= a && c >= b)
		nej = c;
	cout << "Nejvetsi z cisel je " << nej << endl;
	return nej;
}

/* Funkce vype na konzoli sla 'a', 'b' a 'c' v poad od nejvtho po nejmen. */
void usporadej(int a, int b, int c)
{
	cout << "Cisla dle velikosti (od nejvetsiho po nejmensi): " ;
	if (b > a)
	{
		if (c > b)
			cout << c << "  " << b << "  " << a << endl;
		else if (a > c)
			cout << b << "  " << a << "  " << c << endl;
		else
			cout << b << "  " << c << "  " << a << endl;
	}
	else
	{
		if (c > a)
			cout << c << "  " << a << "  " << b << endl;
		else if (c > b)
			cout << a << "  " << c << "  " << b << endl;
		else
			cout << a << "  " << b << "  " << c << endl;
	}
}

